<template>
    <v-card>
        <v-card-title class="headline">{{ $t("ip-adress")}}</v-card-title>
        <v-form ref="importNmap">
            <v-card-text>
                <v-container>
                    <v-text-field 
                        v-model="adress" 
                        v-bind:label="$t('adress')" 
                        :rules="[rules.required, rules.ip]" 
                        required
                    ></v-text-field>
                </v-container>
            </v-card-text>
            <v-card-actions>
                <v-btn color="normal" class="ma-2" @click="cancel" :disabled="disabled">{{ $t("cancel") }}</v-btn>
                <v-spacer></v-spacer>
                <v-btn color="primary" class="ma-2" @click="submit" :disabled="disabled">{{ $t("confirm") }}</v-btn>
            </v-card-actions>
        </v-form>
        
    </v-card>
</template>

<script>
    import APIServices from "@/api/ServicesAPI.js";

    const apiServices = new APIServices();

    export default {
        name: "importNmap",

        data() {
            return {
                adress: "",
                rules: {
                    required: v => !!v || this.$t("required"),
                    ip: v => /[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/.test(v) || this.$t("ip-valid"),
                },
                disabled: false,
            };
        },

        components: {

        },

        methods: {
            async submit() {
                try {
                    if(this.$refs.importNmap.validate()) {
                        console.log("submit");
                        this.disabled = true;
                        let data = await apiServices.importNMAP({
                            adress: this.adress,
                        });
                        console.debug(data);
                        this.$refs.importNmap.reset();
                        this.disabled = false;
                        this.$emit("exit", "importNmap");
                        this.$noty.success(this.$t("service-imported"));
                    }
                } catch (err) {
                    this.disabled = false;
                    console.error(`Error has occured : ${err}`);
                }
            },
            cancel () {
                this.$refs.importNmap.reset();
                this.$emit("exit", "importNmap");
            },

        },
    };
</script>

<i18n>
{
    "en": {
        "ip-adress": "IP adress to use",
        "adress": "IP adress",
        "ip-valid": "Please enter a valid IP adress",
        "service-imported": "Imported services !"
    },
    "fr": {
        "ip-adress": "Adresse IP à utiliser",
        "adress": "Adresse IP",
        "ip-valid": "Veuillez indiquer une adresse IP valide",
        "service-imported": "Services importés !"
    }
}
</i18n>

<style scoped>
    
</style>